; ****************************************************************************
;
;    *** disclaimer goes here ***
;
; ****************************************************************************
;
;   Developer: Perry S. Morris (Relvinian)
;     Created: Nov 7th, 2006  4:15pm
;
; ****************************************************************************
;
; HISTORY:
;    Version 1.0:
;       - Initial file creation
;       - _asm_FreeMemory@4 proc export added
;
; ============================================================================
.486
.model flat

option readonly
option casemap:none
option epilogue:none
option prologue:none
option proc:export


; ----------------------------------------------------------------------------
; System Includes
; ----------------------------------------------------------------------------
include Kernel32.inc


; ----------------------------------------------------------------------------
; Library includes 
; ----------------------------------------------------------------------------


; ----------------------------------------------------------------------------
; Memory library specific defines and global variables
; ============================================================================
extern hProcessHeap:near


.code

; ----------------------------------------------------------------------------
; Prototype:
;   void __stdcall asm_FreeMemory(void* pMemory);
;
; Description:
;   Destroys the memory allocated by asm_AllocMemory() or asm_ReAllocMemory().
;   Once the memory has been freed, the pointer is no longer valid.
;
; Returns:
;   (none)
; ============================================================================
align 4
_asm_FreeMemory@4 proc
    ; get parameters from stack into working registers and validate them
	mov	eax, [esp+4] ; pMemory parameter
	test eax, eax    ; null pointer?
	jz short @F
    cmp dword ptr [eax-4], 0fffefdfch ; must be alloced by asm_AllocMemory
    jne short @F

    ; free the memory block buffer now
	mov edx, [eax-8] ; real starting pointer of memory address
    mov ecx, [hProcessHeap]
	push edx         ; address to free
	push 0           ; must be zero
	push [ecx]       ; process heap handle
	call HeapFree
	
@@:
	ret 4
_asm_FreeMemory@4 ENDP

END